%This script creates the required inputdata for simulation
%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
StartTime=cputime;
%--------------------------------------------------------------------------
%FUEL CONSUMPTION
%CREATING sfocInterpolate AND P_B

%REQUIRED DATA:

%Added resistance
addpath('M:\carita\Prepocessing of data for simulation V5\Added Resistance')
load('AddedRes_range.mat','Hs_int','Tp_int','Vaw_int','h_int'); %for interpolation purposes
load('AddedRes_clean.mat','AddedRes_clean'); %4D Hs=1:14, Tp, vaw, heading. negative resistance removed
load('AddedRes_range_lowHs.mat','lowHs_int'); %for interpolation purposes
load('AddedRes_lowHs_clean.mat','AddedRes_lowHs_clean'); % 4D Hs=0.1:1, -"- 

%Setting ranges for tp, hs and v. Set size of sfocInterpolate and P_B
Tp=3:24;
highHs=1:14;
Vreq=3:18;
heading=0:15:180; 
lowHs=0.1:0.1:0.9;

%FUEL AND POWER MATRIX GENERATION
%For Hs=0.1:0.9 ;
[P_B_lowHs,sfoc_lowHs,V_isl_lowHs]=FuelPower(AddedRes_lowHs_clean,...
    lowHs_int,Tp_int,Vaw_int,h_int,Tp,lowHs,Vreq,heading);

%For Hs=1:14 m;
[P_B_highHs,sfoc_highHs,V_isl_highHs]=FuelPower(AddedRes_clean,...
    Hs_int,Tp_int,Vaw_int,h_int,Tp,highHs,Vreq,heading);

%Merging results Hs=0.1:0.1:0.9 + 1:1:14
[sfocInterpolate,P_B,Hs,v_isl]=FuelPowerMergeV2(sfoc_highHs,P_B_highHs,sfoc_lowHs,...
    P_B_lowHs,lowHs,highHs,V_isl_lowHs,V_isl_highHs);
v_uvsl=v_isl; %NB! NEED TO REMOVE 0 SPEED VALUES AND REPLACE WITH 1 KN TO AVOID INF IN EXTREME WEATHER DURING SIMULATION see remove0v_uvsl.m
tp_uvsl=Tp;
hs_uvsl=Hs;
h_uvsl=heading;

%--------------------------------------------------------------------------
%STATISTICAL FUEL CONSUMPTION
%CREATING cons_v

%statistical data
addpath('M:\carita\Prepocessing of data for simulation V5\Statistical weather')
load('p_HsTp.mat'); %Hs from 1:14 due to function not valid for Hs below 0.8

[cons_v]=stat_fuel_con(sfoc_highHs,P_B_highHs,Vreq,p_HsTp); %[ton/nm]


%--------------------------------------------------------------------------
%SPEED LOSS DATA
%CREATING att_v, f_v, v_ave_att


%VOLUNTARY SPEED REDUCTION
%CREATE att_v

%calculate only for highHs because speed reduction is not relevant for low
%Hs
[att_v]=vol_speed_red(Hs,Tp,heading); 
Hs_vsl=Hs;
Tp_vsl=Tp;

[Tp_vsr_grid,Hs_vsr_grid,h_vsr_grid]=meshgrid(Tp,Hs,heading);
%heading_vsl=heading; called heading in sim_function..

%STATISTICAL REQUIRED SPEED
%CREATE f_v,v_ave_att

Vreq_stat=3:18;
[f_v,v_ave_att]=stat_att_speed(att_v,v_uvsl,lowHs,highHs,Tp,heading,Vreq_stat,p_HsTp);
%use highHs here due to stat function not valid below 0.89m 

ScriptRunTime=(cputime-StartTime)/(60*60);
disp(ScriptRunTime);

save('sim_input.mat','sfocInterpolate','P_B','cons_v','v_uvsl','tp_uvsl','hs_uvsl','att_v','Hs_vsl','Tp_vsl','f_v','v_ave_att','Tp_vsr_grid','Hs_vsr_grid','h_vsr_grid','heading','ScriptRunTime')
