%Written by Carita Gyldenskog Ranvik, Trondheim 10.06.2019
%This script creates the attainable speed 
function [f_v,v_ave_att]=stat_att_speed(V_vsr,V_isl,lowHs,highHs,Tp,heading,Vreq,p_HsTp)

%Declearing variables
Vatt_headwaves=zeros(length(highHs),length(Tp),length(Vreq));
Hs=[lowHs highHs];
[Tp_interp,Hs_interp,h_interp]=meshgrid(Tp,Hs,heading);


%Vatt_headwaves only for hs=1:14 due to statistical limitations of hs to be
%1 m or above. To remove the lowHs part we add a constant
C_lHs=length(lowHs);
for i=1:length(Vreq)
    for j=1:length(Tp)
        for k=1:length(highHs)
            isl=interp3(Tp_interp,Hs_interp,h_interp,V_isl,Tp(j),Hs(k+C_lHs),0);
            vsr=interp3(Tp_interp,Hs_interp,h_interp,V_vsr,Tp(j),Hs(k+C_lHs),0); %0=headwaves
            Vatt_headwaves(k,j,i)=min([Vreq(i) isl vsr]);
        end
    end
end

save('Vatt_headwaves','Vatt_headwaves','Vreq');  

%Declearing variables
%x=hs, y=tp, z=v
[x,y,z]=size(Vatt_headwaves);

Vatt_avr=zeros(1,z); %statistical speed loss
for i=1:z
    for j=1:y
        for k=1:x          
            Vatt_avr(i)=Vatt_avr(i)+p_HsTp(k,j)*Vatt_headwaves(k,j,i);
        end
    end
    
end

%Begge matrisene m ha lik skala for Hs of Tp for at dette skal bli
%riktig
f_v=Vreq;
v_ave_att=Vatt_avr;
plot(Vreq,Vatt_avr)
xlabel('V_{req}')
ylabel('V_{att}')
grid on
saveas(gcf,'V_req vs V_att.fig')
save('stat_data','f_v','v_ave_att')


end
